Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes

# ObjectMgrBase Class Reference

Inheritance diagram for ObjectMgrBase:

List of all members.

## Public Member Functions
def | __init__
def | addNewCurve
def | addNewCurveFromFile
def | addNewObject
def | deselectAll
def | duplicateChild
def | duplicateObject
def | duplicateSelected
def | findActors
def | findNodes
def | findObjectById
def | findObjectByNodePath
def | findObjectByNodePathBelow
def | findObjectsByTypeName
def | flatten
def | genUniqueId
def | getPostSaveData
def | getPreSaveData
def | getSaveData
def | makeSelectedLive
def | onEnterObjectPropUI
def | onLeaveObjectPropUI
def | removeObjectById
def | removeObjectByNodePath
def | replaceObjectWithTypeName
def | reset
def | selectObject
def | selectObjectCB
def | setObjectTransform
def | spawnUpdateObjectUITask
def | traverse
def | updateCurve
def | updateObjectAnim
def | updateObjectAnimFromUI
def | updateObjectColor
def | updateObjectModel
def | updateObjectModelFromUI
def | updateObjectProperties
def | updateObjectProperty
def | updateObjectPropertyUI
def | updateObjectPropValue
def | updateObjectTransform
def | updateObjectUITask
## Public Attributes
| Actor
| currLiveNP
| currNodePath
| editor
| lastUid
| lastUidMod
| lastUidMode
| Nodes
| npIndex
| objDegree
| objects
| objectsLastXform
| saveData

## Detailed Description

    ObjectMgr will create, manage, update objects in the scene

## Constructor & Destructor Documentation

def __init__ | ( |  | self,
|  |  | editor
| ) |  |

Reimplemented in ObjectMgr.

## Member Function Documentation

def addNewCurve | ( |  | self,
|  |  | curveInfo,
|  |  | degree,
|  |  | uid = `None`,
|  |  | parent = `None`,
|  |  | fSelectObject = `True`,
|  |  | nodePath = `None`
| ) |  |

    function to add new curve to the scene

def addNewCurveFromFile | ( |  | self,
|  |  | curveInfo,
|  |  | degree,
|  |  | uid = `None`,
|  |  | parent = `None`,
|  |  | fSelectObject = `True`,
|  |  | nodePath = `None`
| ) |  |

    function to add new curve to the scene from file

def addNewObject | ( |  | self,
|  |  | typeName,
|  |  | uid = `None`,
|  |  | model = `None`,
|  |  | parent = `None`,
|  |  | anim = `None`,
|  |  | fSelectObject = `True`,
|  |  | nodePath = `None`,
|  |  | nameStr = `None`
| ) |  |

    function to add new obj to the scene

def deselectAll | ( |  | self | ) |

def duplicateChild | ( |  | self,
|  |  | nodePath,
|  |  | parent
| ) |  |

def duplicateObject | ( |  | self,
|  |  | nodePath,
|  |  | parent = `None`
| ) |  |

def duplicateSelected | ( |  | self | ) |

def findActors | ( |  | self,
|  |  | parent
| ) |  |

def findNodes | ( |  | self,
|  |  | parent
| ) |  |

def findObjectById | ( |  | self,
|  |  | uid
| ) |  |

def findObjectByNodePath | ( |  | self,
|  |  | nodePath
| ) |  |

def findObjectByNodePathBelow | ( |  | self,
|  |  | nodePath
| ) |  |

def findObjectsByTypeName | ( |  | self,
|  |  | typeName
| ) |  |

def flatten | ( |  | self,
|  |  | newobjModel,
|  |  | model,
|  |  | objDef,
|  |  | uid
| ) |  |

def genUniqueId | ( |  | self | ) |

def getPostSaveData | ( |  | self | ) |

    if there are additional data to be saved after main data
    you can override this function to populate data

def getPreSaveData | ( |  | self | ) |

    if there are additional data to be saved before main data
    you can override this function to populate data

def getSaveData | ( |  | self | ) |

def makeSelectedLive | ( |  | self | ) |

def onEnterObjectPropUI | ( |  | self,
|  |  | event
| ) |  |

def onLeaveObjectPropUI | ( |  | self,
|  |  | event
| ) |  |

def removeObjectById | ( |  | self,
|  |  | uid
| ) |  |

def removeObjectByNodePath | ( |  | self,
|  |  | nodePath
| ) |  |

def replaceObjectWithTypeName | ( |  | self,
|  |  | obj,
|  |  | typeName
| ) |  |

def reset | ( |  | self | ) |

def selectObject | ( |  | self,
|  |  | nodePath,
|  |  | fLEPane = `0`
| ) |  |

def selectObjectCB | ( |  | self,
|  |  | obj,
|  |  | fLEPane
| ) |  |

def setObjectTransform | ( |  | self,
|  |  | uid,
|  |  | xformMat
| ) |  |

def spawnUpdateObjectUITask | ( |  | self | ) |

def traverse | ( |  | self,
|  |  | parent,
|  |  | parentId = `None`
| ) |  |

    Trasverse scene graph to gather data for saving

def updateCurve | ( |  | self,
|  |  | val,
|  |  | obj
| ) |  |

def updateObjectAnim | ( |  | self,
|  |  | anim,
|  |  | obj,
|  |  | fSelectObject = `True`
| ) |  |

    replace object's anim

def updateObjectAnimFromUI | ( |  | self,
|  |  | event,
|  |  | obj
| ) |  |

    replace object's anim with one selected from UI

def updateObjectColor | ( |  | self,
|  |  | r,
|  |  | g,
|  |  | b,
|  |  | a,
|  |  | np = `None`
| ) |  |

def updateObjectModel | ( |  | self,
|  |  | model,
|  |  | obj,
|  |  | fSelectObject = `True`
| ) |  |

    replace object's model

def updateObjectModelFromUI | ( |  | self,
|  |  | event,
|  |  | obj
| ) |  |

    replace object's model with one selected from UI

def updateObjectProperties | ( |  | self,
|  |  | nodePath,
|  |  | propValues
| ) |  |

    When a saved level is loaded,
    update an object's properties
    And call update function if defined.

def updateObjectProperty | ( |  | self,
|  |  | event,
|  |  | obj,
|  |  | propName
| ) |  |

    When an obj's property is updated in UI,
    this will update it's value in data structure.
    And call update function if defined.

def updateObjectPropertyUI | ( |  | self,
|  |  | obj
| ) |  |

def updateObjectPropValue | ( |  | self,
|  |  | obj,
|  |  | propName,
|  |  | val,
|  |  | fSelectObject = `False`,
|  |  | fUndo = `True`
| ) |  |

    Update object property value and
    call update function if defined.

def updateObjectTransform | ( |  | self,
|  |  | event
| ) |  |

def updateObjectUITask | ( |  | self,
|  |  | state
| ) |  |

## Member Data Documentation

Actor

currLiveNP

currNodePath

editor

lastUid

lastUidMod

lastUidMode

Nodes

npIndex

objDegree

objects

objectsLastXform

saveData

All Classes Namespaces Functions Variables Enumerations Enumerator Properties